require File.expand_path('../spec_helper', __FILE__)

describe Consular::AnotherGnomeTerminal do
  it 'should be added as a core to Consular' do
    Consular.cores.must_include Consular::AnotherGnomeTerminal
  end

  it 'should accept linux and gnome-terminal as valid conditions for running' do
    Consular::AnotherGnomeTerminal.expects(:platform).returns("linux")
    Consular::AnotherGnomeTerminal.expects(:`).with("which gnome-terminal").returns("path")

    Consular::AnotherGnomeTerminal.valid_system?.must_equal true
  end

  it 'should reject macos as valid os for running' do
    Consular::AnotherGnomeTerminal.expects(:platform).returns("darwin")
    Consular::AnotherGnomeTerminal.valid_system?.must_equal false
  end

  it "should corrent run termfile" do
    Consular::AnotherGnomeTerminal.any_instance.expects(:`).with(%q{ps aux; uname -r})
    Consular::AnotherGnomeTerminal.any_instance.expects(:`).with(%q{gnome-terminal -t 'test1' --tab  -e 'bash -c '\\''ps a; exec bash'\\' --tab -t 'test' -e 'bash -c '\\''top; exec bash'\\'})

    tmp = Tempfile.new('foo')
    tmp.write(%q{
      run "ps aux"
      run "uname -r"
      window "test1" do
        run "ps a"
        tab "test" do
          run "top"
        end
      end
    })
    tmp.rewind

    core = Consular::AnotherGnomeTerminal.new tmp.path
    core.process!
  end
end
